#include "generator.h"
#include "graph.h"
#include "operator.h"
#include "search_engine.h"
#include "tensor.h"
#include <cstdlib>
#include <iostream>

const int n = 2, c = 1, h = 6, w = 6;
const int f = 1, r = 3, s = 3;

int main() {
    auto i0 = new tpm::Tensor({n, c, h, w});
    auto trans0 = new tpm::TransposeOp(i0, 0, {0, 1, {-1, 2}, 3}, 2);
    i0->dataMalloc();
    auto i0d = i0->getDataPtr();
    for (size_t i = 0; i < i0->size(); ++i)
        i0d[i] = i;
    std::cout << "input: " << std::endl;
    i0->print();

    auto i1 = trans0->compute();
    std::cout << "output 1: " << std::endl;
    i1->print();

    auto trans1 = new tpm::TransposeOp(i1, 2, {{0, 2}, 1, -1, 3}, -2);
    auto i2 = trans1->compute();
    std::cout << "output 2: " << std::endl;
    i2->print();

    delete trans0;
    delete i0;
    delete i1;
    delete i2;

    return 0;
}
